clear, clc, close all
set(0,'DefaultLineLineWidth',1.5)
addpath 'C:\Program Files (x86)\REFPROP\' 

level=["condenser","evaporator"];
Q=0:0.1:1;
for k=1:2
    switch level(k)
        case 'condenser'
            T11=70; %°C
            T12=100; %°C
            Phs=7; %bar
            ref1="co2pentane 0.01-0.99.mix";
            ref2="co2pentane 0.02-0.98.mix";
            ref3="co2pentane 0.03-0.97.mix";
            ref4="co2pentane 0.05-0.95.mix";
            refhs=[ref1,ref2,ref3,ref4];
            Tw=zeros(1,length(Q));
            Tw(1)=T11;
            Trefhs=zeros(length(refhs),length(Q));
            for i=2:length(Q)
                Tw(i)=Tw(i-1)+(T12-T11)/(length(Q)-1); %°C
            end
            for j=1:length(refhs)
                for i=1:length(Q)
                    Trefhs(j,i)=refpropm('T','P',Phs*100,'Q',Q(i),char(refhs(j)))-273.15; %°C
                end
            end
            figure(k)
            hold on
            plot(Q,Tw,'r--')
            plot(Q,Trefhs,'b-')
            xlabel('Refrigerant Quality')
            ylabel('Temperature [°C]')
            legend('Hot Water','High Stage Refrigerant','','','Location','Best')
            title('Condenser at P = 7 bar')
            grid on
            ylim([50,110])
        case 'evaporator'
            T1=40; %°C
            T2=30; %°C
            Pls=3; %bar
            ref1="co2butane 0.01-0.99.mix";
            ref2="co2butane 0.02-0.98.mix";
            ref3="co2butane 0.03-0.97.mix";
            ref4="co2butane 0.05-0.95.mix";
            refls=[ref1,ref2,ref3,ref4];
            Tw=zeros(1,length(Q));
            Tw(1)=T2;
            Trefls=zeros(length(refls),length(Q));
            for i=2:length(Q)
                Tw(i)=Tw(i-1)+(T1-T2)/(length(Q)-1); %°C
            end
            for j=1:length(refls)
                for i=1:length(Q)
                    Trefls(j,i)=refpropm('T','P',Pls*100,'Q',Q(i),char(refls(j)))-273.15; %°C
                end
            end
            figure(k)
            hold on           
            plot(Q,Tw,'g--')
            plot(Q,Trefls,'c-')
            xlabel('Refrigerant Quality')
            ylabel('Temperature [°C]')
            legend('Heat source','Low Stage Refrigerant','','','Location','Best')
            title('Evaporator at P = 3 bar')
            grid on
            ylim([10,45])
    end
end